/**
  ******************************************************************************
  * @file
  * @author
  * @version
  * @date
  * @brief
  * @function List:
  ******************************************************************************
  * @attention
  *
  *
  * <h2><center>&copy; COPYRIGHT 2021 </center></h2>
  ******************************************************************************
  * @History:
  * @Author:
  * @Data:
  * @Version:
*/

/*******************************************************************************
* Include files
********************************************************************************/
#include "Dcm_Types.h"
#include "Dcm_Cfg.h"
#include "common_cfg.h"
#include "system_config.h"
#include "service_27.h"

CONST(Dcm_DspNonDefaultSessionS3ServerType, DCM_VARIABLE) gDcmDspNonDefaultSessionS3Server=5000;/*Unit:ms*/
CONST(DcmDspSessionRow, DCM_VARIABLE) gDcmDspSessionRow[KIND_OF_SESSION]=
{
    {DCM_NO_BOOT, DCM_SESSION_DEFAULT                   ,50u,5000u},
    {DCM_NO_BOOT, DCM_SESSION_PROGRAMMING                   ,50u,5000u},
    {DCM_NO_BOOT, DCM_SESSION_EXTENDED_DIAGNOSTIC                   ,50u,5000u},
    {DCM_NO_BOOT, DCM_SESSION_USERDEFINED1                   ,50u,5000u}
};
#if(DCM_SERVICE_27_ENABLED==STD_ON)
//#define DCM_KEY_LEN 4u
CONST(DcmDspSecurityRow, DCM_VARIABLE)  gDcmDspSecurityRow[KIND_OF_SECURITY_LEVEL]=
{
    {10000u,1u,DCM_KEY_LEN,DCM_SEC_LEV_L1, 0x3u,4u},
    {10000u,1u,DCM_KEY_LEN,DCM_SEC_LEV_L2, 0x3u,4u},
    {10000u,10000u,DCM_KEY_LEN,DCM_SEC_LEV_L3, 0x3u,4u},
    {10000u,10000u,DCM_KEY_LEN,DCM_SEC_LEV_L4, 0x3u,4u},
    {10000u,1u,DCM_KEY_LEN,DCM_SEC_LEV_L5, 0x3u,4u},
    {10000u,1u,DCM_KEY_LEN,DCM_SEC_LEV_L6, 0x3u,4u},
    {10000u,1u,DCM_KEY_LEN,DCM_SEC_LEV_L7, 0x3u,4u}
};
#endif

/* For 0x22 */
#if(DCM_SERVICE_22_ENABLED==STD_ON)
#if(DCM_SERVICE_22_COMBINED_DID==STD_ON)
CONST(Dcm_DspMaxDidToReadType, DCM_VARIABLE) DcmDspMaxDidToRead=1u;
#else
CONST(Dcm_DspMaxDidToReadType, DCM_VARIABLE) DcmDspMaxDidToRead=1u;
#endif
#endif

/* 0x22 */
#if(DCM_SERVICE_22_ENABLED==STD_ON)
CONST(Dcm_22_ServiceInfoType, DCM_VARIABLE)   gDcmDsdSubService_22[NUMBER_OF_READ_DID]=
{

  {0xF100u,1u,4u,   &App_Read0xF100,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0x01a0u,1u,1u,   &App_Read0x01A0,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF1a0u,1u,1u,   &App_Read0xF1A0,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xb070u,1u,4u,   &App_Read0xb070,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0x0005u,1u,5u,   &App_Read0x0005_left_sws,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0x0004u,1u,2u,   &App_Read0x0004_right_sws,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0x0008u,1u,5u,   &App_Read0x0008_right_pick,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xb101u,1u,5u,   &App_Read0xB101_left_menu,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xb075u,1u,1u,   &App_Read0xb075,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xa030u,1u,80u,   &App_Read0xA030,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF1F2u,1u,14u,   &App_Read0xF1F2,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF1F1u,1u,14u,   &App_Read0xF1F1,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF19Eu,1u,14u,   &App_Read0xF19E,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF194u,1u,9u,   &App_Read0xF194,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF192u,1u,24u,   &App_Read0xF192,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF191u,1u,14u,   &App_Read0xF191,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF188u,1u,14u,   &App_Read0xF188,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF181u,1u,15u,   &App_Read0xF181,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF182u,1u,14u,   &App_Read0xF182,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF180u,1u,9u,   &App_Read0xF180,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF186u,1u,1u,   &App_Read0xF186,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF187u,1u,14u,   &App_Read0xF187,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF189u,1u,16u,   &App_Read0xF189,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF18Au,1u,6u,   &App_Read0xF18A,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF18Bu,1u,4u,   &App_Read0xF18B,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF18Cu,1u,15u,   &App_Read0xF18C,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF190u,1u,17u,   &App_Read0xF190,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF193u,1u,5u,   &App_Read0xF193,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF195u,1u,6u,   &App_Read0xF195,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF197u,1u,8u,   &App_Read0xF197,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF198u,1u,20u,   &App_Read0xF198,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF199u,1u,4u,   &App_Read0xF199,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0xF19Du,1u,4u,   &App_Read0xF19D,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
  {0x0003u,1u,5u,   &App_Read0x0003_net_type,(DCM_SEC_LEV_ALL),  (DCM_SESSION_DEFAULT|DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_AND_FUNCTIONAL_REQ_SUPPORTED},
};
#endif
/* 0x2E */
#if(DCM_SERVICE_2E_ENABLED==STD_ON)
CONST(Dcm_2E_ServiceInfoType, DCM_VARIABLE)   gDcmDsdSubService_2E[NUMBER_OF_WRITE_DID]=
{
	{0x01A0u,1u,1u,   &App_Write0x01A0,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF1A0u,1u,1u,   &App_Write0xF1A0,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF112u,1u,8u,   &App_Write0xF112,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF190u,1u,17u,   &App_Write0xF190,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF197u,1u,8u,   &App_Write0xF197,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF198u,1u,20u,   &App_Write0xF198,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF199u,1u,4u,   &App_Write0xF199,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},
	{0xF19Du,1u,4u,   &App_Write0xF19D,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_PROGRAMMING|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED} ,
	{0xF18Cu,1u,15u,   &App_Write0xF18C,DCM_SEC_LEV_SL_39B, (DCM_SESSION_EXTENDED_DIAGNOSTIC),PHYSICAL_REQ_SUPPORTED}
};
#endif

/* 0x2F */
#if(DCM_SERVICE_2F_ENABLED==STD_ON)
CONST(Dcm_2F_ServiceInfoType, DCM_VARIABLE)   gDcmDsdSubService_2F[NUMBER_OF_CONTROL_DID]=
{
      {0xff00u,DCM_SEC_LEV_SL_ALL,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED,{0u,2u,0u},&App_ReturnControlToEcu0xff00,DCM_NULL,DCM_NULL,&App_ShortTermAdjustment0xff00,DCM_NULL},
      {0x2020u,DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED,{0u,1u,0u},&App_ReturnControlToEcu0x2020,DCM_NULL,DCM_NULL,&App_ShortTermAdjustment0x2020,DCM_NULL},
      {0x5001u,DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED,{0u,1u,0u},&App_ReturnControlToEcu0x5001,DCM_NULL,DCM_NULL,&App_ShortTermAdjustment0x5001,DCM_NULL},
};
#endif

/* 0x31 */
#if(DCM_SERVICE_31_ENABLED==STD_ON)

CONST(DcmDspRoutine, DCM_VARIABLE)  DcmDspRoutineIdentifierTable_31[NUMBER_OF_RID]=
{
    {0x0203u,1u,0u,1u,&App_StartRoutine0x0203,&App_StopRoutine0x0203,&App_RequestRoutineResults0x0203,{{DCM_SEC_LEV_ALL,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{1u},{0u},{1u},{0u},{1u}}},
    #if 0
    {0x0206u,1u,0u,1u,&App_StartRoutine0x0206,DCM_NULL,DCM_NULL,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{0u},{0u},{0u},{0u},{1u}}},
    {0x01b0u,1u,0u,1u,&App_StartRoutine0x01b0,DCM_NULL,&App_RequestRoutineResults0x01b0,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC),PHYSICAL_REQ_SUPPORTED},{16u},{1u},{1u},{16u},{1u}}},
    {0x04FEu,1u,0u,1u,&App_StartRoutine0x04FE,DCM_NULL,&App_RequestRoutineResults0x04FE,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{1u},{1u},{1u},{1u},{1u}}},
    {0x5902u,1u,0u,1u,&App_StartRoutine0x5902,&App_StopRoutine0x5902,&App_RequestRoutineResults0x5902,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{1u},{0u},{1u},{0u},{1u}}},
    {0x5903u,1u,0u,1u,&App_StartRoutine0x5903,&App_StopRoutine0x5903,&App_RequestRoutineResults0x5903,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{1u},{0u},{1u},{0u},{1u}}},
    {0x5904u,1u,0u,1u,&App_StartRoutine0x5904,&App_StopRoutine0x5904,&App_RequestRoutineResults0x5904,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{1u},{0u},{1u},{0u},{1u}}},
    {0xDF30u,1u,0u,1u,&App_StartRoutine0xDF30,&App_StopRoutine0xDF30,&App_RequestRoutineResults0xDF30,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{7u},{0u},{1u},{2u},{1u}}},
    {0xDF31u,1u,0u,1u,&App_StartRoutine0xDF31,&App_StopRoutine0xDF31,&App_RequestRoutineResults0xDF31,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{5u},{0u},{1u},{2u},{1u}}},
    {0xDF32u,1u,0u,1u,&App_StartRoutine0xDF32,&App_StopRoutine0xDF32,&App_RequestRoutineResults0xDF32,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{9u},{0u},{1u},{2u},{1u}}},
    {0xDF33u,1u,0u,1u,&App_StartRoutine0xDF33,DCM_NULL,&App_RequestRoutineResults0xDF33,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{12u},{0u},{0u},{0u},{1u}}},
    {0xDF34u,1u,0u,1u,&App_StartRoutine0xDF34,&App_StopRoutine0xDF34,&App_RequestRoutineResults0xDF34,{{DCM_SEC_LEV_SL_39B,(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1),PHYSICAL_REQ_SUPPORTED},{2u},{0u},{1u},{2u},{1u}}},
    {0xDF35u,1u,0u,1u,&App_StartRoutine0xDF35,DCM_NULL,&App_RequestRoutineResults0xDF35,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{19u},{0u},{0u},{2u},{1u}}},
    {0xDF36u,1u,0u,1u,&App_StartRoutine0xDF36,DCM_NULL,&App_RequestRoutineResults0xDF36,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{5u},{0u},{0u},{4u},{1u}}},
    {0xDF37u,1u,0u,1u,&App_StartRoutine0xDF37,DCM_NULL,&App_RequestRoutineResults0xDF37,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{1u},{0u},{0u},{8u},{1u}}},
    {0xDF38u,1u,0u,1u,&App_StartRoutine0xDF38,DCM_NULL,&App_RequestRoutineResults0xDF38,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{1u},{0u},{0u},{6u},{1u}}},
    {0xDF39u,1u,0u,1u,&App_StartRoutine0xDF39,&App_StopRoutine0xDF39,&App_RequestRoutineResults0xDF39,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{19u},{0u},{1u},{2u},{1u}}},
    {0xDF3Au,1u,0u,1u,&App_StartRoutine0xDF3A,&App_StopRoutine0xDF3A,&App_RequestRoutineResults0xDF3A,{{DCM_SEC_LEV_SL_39B,DCM_SESSION_USERDEFINED1,PHYSICAL_REQ_SUPPORTED},{19u},{0u},{1u},{1u},{1u}}},
    {0xFF02u,1u,0u,1u,&App_StartRoutine0xFF02,DCM_NULL,DCM_NULL,{{(DCM_SEC_LEV_SL_39B),(DCM_SESSION_EXTENDED_DIAGNOSTIC|DCM_SESSION_USERDEFINED1|DCM_SESSION_PROGRAMMING),PHYSICAL_REQ_SUPPORTED},{0u},{0u},{0u},{0u},{1u}}},
    #endif
};
#endif

