/** ##########################################################################
**     Filename  : uart_cfg.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :  uart
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --

** #########################################################################*/


#ifndef UART_CFG_H__
#define UART_CFG_H__


/*---------------------------------------------------------------------------
* I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include  "common_types.h"
#include "cpu.h"


/*---------------------------------------------------------------------------
* D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/
//#define USART_0_EN
//#define USART_1_EN
//#define USART_3_EN
//#define USART_4_EN
#define USART_5_EN

//#define UART_TEST_EN  1u	//test
#define UART_DEBUG_EN  1u	//debug

//#define UART_INSERT_PROTOCAL  1u	//

#define UART_TIME_UNIT 1u  //
#define UART_RECOVERY_TIMEOUT (5u/UART_TIME_UNIT)  //

#define UARTx   UART5
//#define UARTx_IRQn  UART2_IRQn
#define UART_TX_BUFF_LENGTH     10u
#define UART_RX_BUFF_LENGTH     24u


#define UART_CRITICAL_ENTER() System_DisableIrqGlobal()
#define UART_CRITICAL_EXIT()  System_EnableIrqGlobal()


/***********************************/

/*---------------------------------------------------------------------------
* T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
* G L O B A L   V A R I A B L E S
* only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
* C O N S T A N T S
----------------------------------------------------------------------------*/
#ifdef USART_0_EN
extern FL_UART_InitTypeDef g_UART0_InitStruct ;
#endif
#ifdef USART_1_EN
extern FL_UART_InitTypeDef g_UART1_InitStruct ;
#endif
#ifdef USART_3_EN
extern FL_UART_InitTypeDef g_UART3_InitStruct ;
#endif
#ifdef USART_4_EN
extern FL_UART_InitTypeDef g_UART4_InitStruct ;
#endif
#ifdef USART_5_EN
extern FL_UART_InitTypeDef g_UART5_InitStruct ;
#endif

/*---------------------------------------------------------------------------
* F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/

#ifdef USART_0_EN
void usart_0_gpio_init(void);
#endif
#ifdef USART_1_EN
void usart_1_gpio_init(void);
#endif
#ifdef USART_3_EN
void usart_3_gpio_init(void);
#endif
#ifdef USART_4_EN
void usart_4_gpio_init(void);
#endif
#ifdef USART_5_EN
void usart_5_gpio_init(void);
#endif


void uart_app_test_task(void);




#endif
