/** ##########################################################################
**     Filename  : i2c_simu.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :  模拟I2C
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef I2C_SIMU__H
#define I2C_SIMU__H

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"
#include "error.h"
#include "i2c_simu_cfg.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
- only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/
void i2c_simu_init(void);
void i2c_simu_task(void);
void i2c_simu_start(void);
void i2c_simu_stop(void);
u8 i2c_simu_wait_ack(void);
void i2c_simu_ack(void);
void i2c_simu_nack(void);
void i2c_simu_send_byte(i2c_simu_data_t txd);
i2c_simu_data_t i2c_simu_read_byte(i2c_simu_ack_t ack);



#endif /* I2C_SIMU__H */

/* [] END OF FILE */
