/** ##########################################################################
**     Filename  : i2c_simu_cfg.c
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :  模拟I2C
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "i2c_simu.h"
#include "common_memory.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- S T A T I C   V A R I A B L E S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
|Prototype          : void i2c_simu_sda_init_output(void)
|Called by          : None
|Preconditions      : None
|Input parameters   : None
|Output parameters  : None
|Return value       : None
|Description        : 把SDA设为输出模式
----------------------------------------------------------------------------*/
void i2c_simu_sda_init_output(void)
{
	#ifdef I2C_SIMU_GPIO_CFD_EN
	FL_GPIO_InitTypeDef GPIO_InitStruct = {0};

	GPIO_InitStruct.pin             = I2C0_SDA_PIN_MASK;
	GPIO_InitStruct.mode            = FL_GPIO_MODE_OUTPUT;
	GPIO_InitStruct.outputType      = FL_GPIO_OUTPUT_PUSHPULL;  //FL_GPIO_OUTPUT_OPENDRAIN
	GPIO_InitStruct.pull            = FL_DISABLE;
	GPIO_InitStruct.remapPin        = I2C0_SCL_REPIN;  //注意
	GPIO_InitStruct.analogSwitch    = FL_DISABLE;
	FL_GPIO_Init(I2C0_SDA_GPIO, &GPIO_InitStruct);
	#endif
} /* End of function i2c_simu_sda_init_output*/

/*---------------------------------------------------------------------------
|Prototype          : void i2c_simu_sda_init_input(void)
|Called by          : None
|Preconditions      : None
|Input parameters   : None
|Output parameters  : None
|Return value       : None
|Description        : 把SDA设为输入模式
----------------------------------------------------------------------------*/
void i2c_simu_sda_init_input(void)
{
	#ifdef I2C_SIMU_GPIO_CFD_EN
	FL_GPIO_InitTypeDef GPIO_InitStruct = {0};

	GPIO_InitStruct.pin             = I2C0_SDA_PIN_MASK;
	GPIO_InitStruct.mode            = FL_GPIO_MODE_INPUT;
	GPIO_InitStruct.outputType      = FL_GPIO_OUTPUT_PUSHPULL;  //FL_GPIO_OUTPUT_OPENDRAIN
	GPIO_InitStruct.pull            = FL_DISABLE;
	GPIO_InitStruct.remapPin        = I2C0_SCL_REPIN;  //注意
	GPIO_InitStruct.analogSwitch    = FL_DISABLE;
	FL_GPIO_Init(I2C0_SDA_GPIO, &GPIO_InitStruct);
	#endif
} /* End of function i2c_simu_sda_init_input*/

/*---------------------------------------------------------------------------
|Prototype          : void i2c_simu_scl_init_output(void)
|Called by          : None
|Preconditions      : None
|Input parameters   : None
|Output parameters  : None
|Return value       : None
|Description        : 把SDA设为输出模式
----------------------------------------------------------------------------*/
void i2c_simu_scl_init_output(void)
{
	#ifdef I2C_SIMU_GPIO_CFD_EN
	FL_GPIO_InitTypeDef GPIO_InitStruct = {0};

	GPIO_InitStruct.pin             = I2C0_SCL_PIN_MASK;
	GPIO_InitStruct.mode            = FL_GPIO_MODE_OUTPUT;
	GPIO_InitStruct.outputType      = FL_GPIO_OUTPUT_PUSHPULL;  //FL_GPIO_OUTPUT_OPENDRAIN
	GPIO_InitStruct.pull            = FL_DISABLE;
	GPIO_InitStruct.remapPin        = I2C0_SCL_REPIN;  //注意
	GPIO_InitStruct.analogSwitch    = FL_DISABLE;
	FL_GPIO_Init(I2C0_SCL_GPIO, &GPIO_InitStruct);
	#endif
} /* End of function i2c_simu_scl_init_output*/

/*---------------------------------------------------------------------------
|Prototype          : void i2c_simu_scl_init_input(void)
|Called by          : None
|Preconditions      : None
|Input parameters   : None
|Output parameters  : None
|Return value       : None
|Description        : 把SDA设为输入模式
----------------------------------------------------------------------------*/
void i2c_simu_scl_init_input(void)
{
	#ifdef I2C_SIMU_GPIO_CFD_EN
	FL_GPIO_InitTypeDef GPIO_InitStruct = {0};

	GPIO_InitStruct.pin             = I2C0_SCL_PIN_MASK;
	GPIO_InitStruct.mode            = FL_GPIO_MODE_INPUT;
	GPIO_InitStruct.outputType      = FL_GPIO_OUTPUT_PUSHPULL;  //FL_GPIO_OUTPUT_OPENDRAIN
	GPIO_InitStruct.pull            = FL_DISABLE;
	GPIO_InitStruct.remapPin        = I2C0_SCL_REPIN;  //注意
	GPIO_InitStruct.analogSwitch    = FL_DISABLE;
	FL_GPIO_Init(I2C0_SCL_GPIO, &GPIO_InitStruct);
	#endif
} /* End of function i2c_simu_scl_init_input*/

/*---------------------------------------------------------------------------
|Prototype          : void i2c_simu_delay_us(i2c_simu_delay_us_t cnt)
|Called by          : None
|Preconditions      : None
|Input parameters   : None
|Output parameters  : None
|Return value       : None
|Description        : 延时，需要实测
----------------------------------------------------------------------------*/
void i2c_simu_delay_us(i2c_simu_delay_us_t cnt)
{
	//uint32_t  u32cnt = 1;
	while(cnt--)
	{
   //     u32cnt = 1;
	//	while(u32cnt--);
	}
} /* End of function i2c_simu_delay_us*/



/* [] END OF FILE */
