/** ##########################################################################
**     Filename  : i2c_simu_cfg.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :  模拟I2C
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef I2C_SIMU_CFG__H
#define I2C_SIMU_CFG__H

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"
#include "error.h"
#include "cpu.h"
#include "gpio.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/
//#define I2C_SIMU_GPIO_CFD_EN
//#define I2C_SIMU_DEBUG_EN
//#define I2C_SIMU_TEST_EN

#define IIC_SIMU_STATUS_NULL 0u
#define IIC_SIMU_STATUS_SUCCESS 1u
#define IIC_SIMU_STATUS_NACK 2u

#define IIC_SIMU_LEN_ERROR 4u
//这些时间，要实测去配
#define I2C_SIMU_START_STOP_DELAY 12u
#define I2C_SIMU_WAIT_ACK_DELAY 8u
#define I2C_SIMU_ACK_WAIT_DELAY 200u
#define I2C_SIMU_ACK_DELAY 8u
#define I2C_SIMU_NACK_DELAY 8u
#define I2C_SIMU_SEND_DATA_DELAY 8u
#define I2C_SIMU_SEND_SCL_H_DELAY 36u
#define I2C_SIMU_SEND_SCL_L_DELAY 20u
#define I2C_SIMU_READ_DATA_DELAY 36u
#define I2C_SIMU_READ_DATA_DELAY1 8u

#ifdef I2C_SIMU_GPIO_CFD_EN
#define I2C_SIMU_SCL_HIGH()    //FL_GPIO_SetOutputPin(I2C0_SCL_GPIO, I2C0_SCL_PIN_MASK)
#define I2C_SIMU_SCL_LOW()   //FL_GPIO_ResetOutputPin(I2C0_SCL_GPIO, I2C0_SCL_PIN_MASK)
#define I2C_SIMU_SDA_HIGH()   // FL_GPIO_SetOutputPin(I2C0_SDA_GPIO, I2C0_SDA_PIN_MASK)
#define I2C_SIMU_SDA_LOW()   //FL_GPIO_ResetOutputPin(I2C0_SDA_GPIO, I2C0_SDA_PIN_MASK)
#define I2C_SIMU_READ_SDA_PIN() //FL_GPIO_GetInputPin(I2C0_SDA_GPIO,I2C0_SDA_PIN_MASK)
#else
#define I2C_SIMU_SCL_HIGH()    //FL_GPIO_SetOutputPin(I2C0_SCL_GPIO, I2C0_SCL_PIN_MASK)
#define I2C_SIMU_SCL_LOW()   //FL_GPIO_ResetOutputPin(I2C0_SCL_GPIO, I2C0_SCL_PIN_MASK)
#define I2C_SIMU_SDA_HIGH()    //FL_GPIO_SetOutputPin(I2C0_SDA_GPIO, I2C0_SDA_PIN_MASK)
#define I2C_SIMU_SDA_LOW()   //FL_GPIO_ResetOutputPin(I2C0_SDA_GPIO, I2C0_SDA_PIN_MASK)
#define I2C_SIMU_READ_SDA_PIN() (0)//FL_GPIO_GetInputPin(I2C0_SDA_GPIO,I2C0_SDA_PIN_MASK)
#endif

/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/
typedef u16 i2c_simu_delay_us_t;
typedef u8 i2c_simu_data_t;
typedef u8 i2c_simu_ack_t;

/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
- only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/
void i2c_simu_sda_init_output(void);
void i2c_simu_sda_init_input(void);
void i2c_simu_scl_init_output(void);
void i2c_simu_scl_init_input(void);
void i2c_simu_delay_us(i2c_simu_delay_us_t cnt);



#endif  /* I2C_SIMU_CFG__H */

/* [] END OF FILE */
