/** ##########################################################################
**     Filename  : key_encode_driver.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      : 滚轮，
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef KEY_ENCODER_DRIVER__H
#define KEY_ENCODER_DRIVER__H

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"
#include "key_encoder_driver_cfg.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/
typedef struct
{
	u8 input0;   //0 dec 1 inc
	u8 input1;
	u8 pre_input0;
	u8 pre_input1;
	u8 event_num;
	u8 event[NUM_OF_KEY_ENCODER_EVENT];
	u8 write_index;
	u8 read_index;
	u8 state;
	u8 result;
	u16 time_count;
	u8 input0_changed;
	u8 input1_changed;

}key_encoder_s;

/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
- only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/
void key_encoder_driver_init(void);									//按键初始化
void key_encoder_driver_task(void);									//按键任务周期调用
u8 key_encoder_get_event(void);
void key_encoder_driver_goto_sleep(void);
void key_encoder_driver_goto_wakeup(void);
//void key_encoder_set_col_count(u8 rol_count);



#endif /* KEY_ENCODER_DRIVER__H */

/* [] END OF FILE */
