/** ##########################################################################
**     Filename  : key_encoder_driver_cfg.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      : 滚轮，
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef KEY_ENCODER_DRIVER_CFG__H
#define KEY_ENCODER_DRIVER_CFG__H

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"
#include "common_cfg.h"
#include "gpio.h"
#include "cpu.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/
#define KEY_ENCODER_EN
//#define KEY_ENCODER_FULL_CYCLE_TRIG  //一格全周期4个波形，，半周期 2个波形
//#define KEY_ENCODER_INTRRUPT_MODE  1  //IO中断方式
//#define KEY_ENCODER_DEBUG_EN


#define KEY_ENCODER_ENTER_CRITICAL() 	System_DisableIrqGlobal()
#define KEY_ENCODER_EXIT_CRITICAL()  	System_EnableIrqGlobal()


#define KEY_ENCODER_STATE_IDLE          0u
#define KEY_ENCODER_STATE_1             1u
#define KEY_ENCODER_STATE_2             2u
#define KEY_ENCODER_STATE_WAIT_RELEASE  3u
#define KEY_ENCODER_STATE_ERROR         4u



#define NUM_OF_KEY_ENCODER_EVENT        10u


#define KEY_ENCODER_DIR_REVERSE  //方向翻转
#ifdef KEY_ENCODER_DIR_REVERSE
    //有效电平
    #define KEY_ENCODER_VALID_LEVEL 1u
    //待机电平
    #define KEY_ENCODER_IDLE_LEVEL 0u
#else
    //有效电平
    #define KEY_ENCODER_VALID_LEVEL 0u
    //待机电平
    #define KEY_ENCODER_IDLE_LEVEL 1u
#endif

#define KEY_ENCODER_EVENT_NULL 0U
#define KEY_ENCODER_EVENT_1 1U
#define KEY_ENCODER_EVENT_2 2U

#define KEY_ENCODER_EVENT_UP KEY_ENCODER_EVENT_1
#define KEY_ENCODER_EVENT_DOWN KEY_ENCODER_EVENT_2

#if 0  //要以实际项目GPIO
#define KEY_ENCODER_INPUT_0_PIN //GPIO_GetPinLevel(KEY_ENCODER_1_GPIO,KEY_ENCODER_1_PIN_ID)
#define KEY_ENCODER_INPUT_1_PIN //GPIO_GetPinLevel(KEY_ENCODER_2_GPIO,KEY_ENCODER_2_PIN_ID)
#else
#define KEY_ENCODER_INPUT_0_PIN gpio_read_pin_input(KEY_1_ENCODE_GPIO,KEY_1_ENCODE_PIN_MASK)
#define KEY_ENCODER_INPUT_1_PIN gpio_read_pin_input(KEY_2_ENCODE_GPIO,KEY_2_ENCODE_PIN_MASK);
#endif




#define KEY_ENCODER_TIME_UNIT 1u  //1ms
#define KEY_ENCODER_TIME_OUT  (5000u/KEY_ENCODER_TIME_UNIT)



/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
- only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/

void key_encoder_driver_cfg_init(void);


#endif /* KEY_ENCODER_DRIVER_CFG__H */

/* [] END OF FILE */
