/*****************************************************************************
**	Filename  : keyboard_drive_cfg.c
**	Project   :
**	Module	  :
**	Processor : Freescale S12Z
**	Date/Time : 2019-09-04, 9:00
**	Abstract  :
**	Contents  :
**	Author	  : Lyj
**	http	  :
**	mail	  :
**	--------------------------------------------------------------------------
**
**	--------------------------------------------------------------------------
******************************************************************************/

/*****************************************************************************
* Include Files
*****************************************************************************/
#include "gpio.h"
#include "key_digital_driver.h"

/*****************************************************************************
* Defines
*****************************************************************************/

/*GEELY:The de-bounce time shall be 20 ms for pulling a switch and 20 ms for releasing a switch. At 5 ms sample
		rate this is equal to 4 samples before switching the state of a switch.*/

/*****************************************************************************
* Macros
*****************************************************************************/

/*****************************************************************************
* Type Defines
*****************************************************************************/

/*****************************************************************************
*Static Variable
*****************************************************************************/

/*****************************************************************************
*Global Variable
*****************************************************************************/
/*****************************************************************************
*Constant
*****************************************************************************/

/*****************************************************************************
**	--------------------------------------------------------------------------
**	下述代码是基于Freescale mc9s12g BSP,其他单片机则需要修改
**	--------------------------------------------------------------------------
******************************************************************************/
/*PRQA S 4571 EOF*/
/*PRQA S 4397 EOF*/

#ifdef KEY_DIGITAL_DRIVER_DEBUG
typedef struct
{
	u8 input_buf[KEY_DIGITAL_DRIVER_KEY_TOTAL];
}key_digital_driver_debug_s;
static key_digital_driver_debug_s g_key_digital_driver_debug = 
{
	0xffu,
	0xffu,
	0xffu,
	0xffu,
	//0xffu,
	//0xffu,
	//0xffu,
};
#endif

/***各种按键的时间配置部分******/
const key_digital_driver_cfg_tab_s g_key_digital_driver_cfg_tab[KEY_DIGITAL_DRIVER_KEY_TOTAL]  =  //特殊情况，把解码器的两个，也在这里初始化
{
	{KEY_ID_1,		KEY_1_GPIO, KEY_1_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_2,		KEY_2_GPIO, KEY_2_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_3,		KEY_3_GPIO, KEY_3_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_4,		KEY_4_GPIO, KEY_4_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_VOLICE_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_5,		KEY_5_GPIO, KEY_5_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_6,		KEY_6_GPIO, KEY_6_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
	{KEY_ID_7,		KEY_7_GPIO, KEY_7_PIN_MASK, 	GPIO_LEVEL_LOW,	KEY_DIGITAL_DITHERING_TIME,KEY_DIGITAL_LONGDOWN_TIMEOUT,KEY_STUCK_TIMEOUT_20S},
};




/*****************************************************************************
|Prototype         :
|Called by         :
|Preconditions     : -
|Input parameters  : None
|Output parameters : None
|Return value      : None
|Description       :
*****************************************************************************/
void key_digital_driver_cfg_init(void)
{
	//己在gpio初始化
	#if 0
	u8 l_result=0,key_id_count;
	FL_GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.mode            = FL_GPIO_MODE_INPUT;
	GPIO_InitStruct.outputType      = FL_GPIO_OUTPUT_PUSHPULL;
	GPIO_InitStruct.pull            = FL_DISABLE;
	GPIO_InitStruct.remapPin        = FL_DISABLE;
	GPIO_InitStruct.analogSwitch    = FL_DISABLE;
	for(key_id_count=0u;key_id_count<KEY_DIGITAL_DRIVER_KEY_TOTAL;key_id_count++)
	{
		GPIO_InitStruct.pin             = g_key_digital_driver_cfg_tab[key_id_count].pin_id;
		FL_GPIO_Init(g_key_digital_driver_cfg_tab[key_id_count].gpio_base, &GPIO_InitStruct);
	}
	#endif
}





#ifdef KEY_DIGITAL_DRIVER_DEBUG
u8 key_digital_driver_cfg_debug_read_pin(u8 id)
{
	u8 l_result=0u;
	l_result = g_key_digital_driver_debug.input_buf[id];
	return l_result;
}
#endif

