/****************************************************************************
**	Filename  : key_digital_driver
**	Project   :
**	Module	  :
**	Processor :
**	Date/Time :
**	Abstract  :
**	Contents  :
**	Author	  : mingyea
**	http	  :
**	mail	  :
**	--------------------------------------------------------------------------
**
**	--------------------------------------------------------------------------
*****************************************************************************/
#ifndef _KEY_DIGITAL_DRIVER_CFG_H_
#define _KEY_DIGITAL_DRIVER_CFG_H_

#include "common_types.h"
#include "Cpu.h"
#include "gpio.h"
#include "key_com_cfg.h"
/*****************************************************************************
* Include Files
*****************************************************************************/

/*****************************************************************************
* Defines
*****************************************************************************/
#define KEY_DIGITAL_EN  1u	//数字按键使能


#define KEY_DIGITAL_DRIVER_DEBOUNCE_INIT  (0u/KEY_DIGITAL_DRIVER_TIME_UNIT)   //回讀時，表示錯誤值

typedef struct
{
	u8 				key_id;
	GPIO_Type*		gpio_base;
	gpio_id_t 		pin_id;  //  GPIO_PinType
	gpio_output_level_e		valid_level;	/*有效电平*/  //
	u16	debounce_time;		/*消抖，用於短按和彈起*/
	u16	long_down_time;		/*用於長按*/
	u16	stick_time;		/*用於卡住*/
}key_digital_driver_cfg_tab_s;		/*按键定义*/

/*****************************************************************************
**	--------------------------------------------------------------------------
**	根据不同项目IO定义修改按键KID，与位域的名称
**	--------------------------------------------------------------------------
******************************************************************************/

/*ALL KEY ID*/
#define KEY_ID_1		0u		//
#define KEY_ID_2		1u		//
#define KEY_ID_3		2u		//
#define KEY_ID_4		3u		//
#define KEY_ID_5		4u		//
#define KEY_ID_6		5u		//
#define KEY_ID_7		6u		//

#define KEY_DIGI_ID_PREV  KEY_ID_1   //向上搜台
#define KEY_DIGI_ID_MUTE  KEY_ID_2   //静音
#define KEY_DIGI_ID_NEXT  KEY_ID_3   //向下搜台
#define KEY_DIGI_ID_VOICE  KEY_ID_4   //语音
#define KEY_DIGI_ID_PHONE  KEY_ID_5   //电话
#define KEY_DIGI_ID_RMENU  KEY_ID_6   //右菜单
#define KEY_DIGI_ID_RPICK  KEY_ID_7   //右拨片

#define KEY_DIGITAL_DRIVER_KEY_TOTAL		7u

/*配置分割线********下面的宏根据实际项目进行配置****/

/*配置touch按键的数量、touch按键+普通IO按键的总数量*/


#define KEY_DIGITAL_DRIVER_ENTER_CRITICAL() 		System_DisableIrqGlobal()
#define KEY_DIGITAL_DRIVER_EXIT_CRITICAL()  		System_EnableIrqGlobal()

extern const key_digital_driver_cfg_tab_s g_key_digital_driver_cfg_tab[KEY_DIGITAL_DRIVER_KEY_TOTAL] ;

/*****************************************************************************
* Macros
*****************************************************************************/

/*****************************************************************************
* Type Defines
*****************************************************************************/

/*****************************************************************************
*Static Variable
*****************************************************************************/

/*****************************************************************************
*Global Variable
*****************************************************************************/

/*****************************************************************************
*Constant
*****************************************************************************/

/*****************************************************************************
*Function Prototype
*****************************************************************************/
/*****************************************************************************
**	--------------------------------------------------------------------------
**
**	--------------------------------------------------------------------------
******************************************************************************/
void key_digital_driver_cfg_init(void);

//#define KEY_DIGITAL_INIT_INVALID  1  //数字按键，上电无效


//#define KEY_DIGITAL_DRIVER_DEBUG  1  /*DEBUG 模擬有按鍵*/


#ifdef KEY_DIGITAL_DRIVER_DEBUG
u8 key_digital_driver_cfg_debug_read_pin(u8 id);
#endif

/*extern */
#endif /* end __KEY_H */
/*****************************************************************************
**                            End Of File
******************************************************************************/
