﻿/**
	******************************************************************************
	* @file    boot_app.c
	* @author  Mingyea Asamiya
	* @version V1.0.0
	* @date    2017-01-19
	* @brief
	* @function List:
	******************************************************************************
	* @attention
	*
	*
	* <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
	******************************************************************************
	* @History:
	* @Author:
	* @Data:
	* @Version:
	*/


#include "system_config.h"
//#include "common_timer.h"
#include "random_pseudo.h"
#include "service_27.h"



static const unsigned char key_u8[4] = { 0x00U, 0x00U, 0x00U, 0x17U };
static const u32 key_u32= 0x00000017;

static u8 g_aes128_seed[SERVICE_SEED_LEN_MAX] ;

/* BEGIN_FUNCTION_HDR
************************************************************************************************
* Function Name : service_27_init
*
* Description   : Set the reprogramming flag and reset the ECU.
*
* Inputs        : none
*
* Outputs       : none
*
* Limitations   : Only for Bootloader
*
************************************************************************************************
END_FUNCTION_HDR */
void service_27_init(void)
{
	//service_27_test();
	//aes128_cbc_init();
}

void service_27_generate_seed(void)
{
	#if 1
	random_start();
	random_get(&g_aes128_seed[0],SERVICE_SEED_LEN_VALID);
	//pcks7(&g_aes128_seed[0],SERVICE_SEED_LEN_VALID,&g_aes128_seed[0],SERVICE_SEED_LEN_MAX);
	#else
	g_aes128_seed[0] =0x12;
	g_aes128_seed[1] =0x34;
	g_aes128_seed[2] =0x56;
	g_aes128_seed[3] =0x78;
	#endif
}


void service_27_get_seed(u8 *pdata,u8 len)
{
	u8 i;
	for(i=0;i<SERVICE_SEED_LEN_MAX;i++)
	{
		pdata[i] = g_aes128_seed[i];
	}
}

u8 service_27_get_seed_element(u8 buf_id)
{
	u8 l_bufid ;
	l_bufid = buf_id;
	if(l_bufid<SERVICE_SEED_LEN_MAX)
	{

	}
	else
	{
		l_bufid=0;
	}
	return 	g_aes128_seed[l_bufid];
}



/******************************************************************************
* Name         :GetKey
* Called by    :
* Preconditions:
* Parameters   :N/A
* Return code  :N/A
* Description  :N/A
*
******************************************************************************/
void service_27_get_key(u8 Dcm_SecuirityLevel, u8* p_key)
{
	u32 l_seed =0;
	u32 l_result=0;
	u32 l_key;

	l_seed= ((u32)g_aes128_seed[0]<<24) | ((u32)g_aes128_seed[1]<<16) | ((u32)g_aes128_seed[2]<<8) | ((u32)g_aes128_seed[3]);
	switch(Dcm_SecuirityLevel)
	{
		case 0x01:  //值是0x01
			l_result = ((((l_seed >> 1) ^ l_seed) <<3) ^ (l_seed >>2));
			l_key = l_result ^ key_u32;
			p_key[0] = l_key>>24;
			p_key[1] = l_key>>16;
			p_key[2] = l_key>>8;
			p_key[3] = l_key;
		break;

		case 0x05: //值是0x05
			l_result = ((((l_seed >> 1) ^ l_seed) <<3) ^ (l_seed >>2));
			l_key = l_result ^ key_u32;
			p_key[0] = l_key>>24;
			p_key[1] = l_key>>16;
			p_key[2] = l_key>>8;
			p_key[3] = l_key;
		break;
		default:
		 break;
	}
}


