/** ##########################################################################
**     Filename  : system_voltage_manage_cfg.h
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date        Ver      Author             Description

**  -20230620-  V01-- --Linboyi---            --初版--
** #########################################################################*/
#ifndef _SYSTEM_VOLTAGE_MANAGE_CFG_H
#define _SYSTEM_VOLTAGE_MANAGE_CFG_H

/*****************************************************************************
* I N C L U D E   F I L E S
*****************************************************************************/
#include "common_types.h"
#include "adc_cfg.h"

/*****************************************************************************
* D E F I N E S / M A C R O S
*****************************************************************************/
#define SYSTEM_VOLTAGE_MANAGE_DEBUG_EN  0u


#define SYSTEM_VOLTAGE_MANAGE_TASK_CYCLE_TIME   2u
#define SYSTEM_VOLTAGE_MODE_UNKNOWN_DEBOUNCE_TIME   (100u/SYSTEM_VOLTAGE_MANAGE_TASK_CYCLE_TIME)

#define FUNC_SYSTEM_VOLTAGE_MANAGE_ID   0u
#define DTC_SYSTEM_VOLTAGE_MANAGE_ID    1u
#define COMM_SYSTEM_VOLTAGE_MANAGE_ID   2u


#define SYSTEM_VOLTAGE_MODE_NORMAL_CFG_ID 0u
#define SYSTEM_VOLTAGE_MODE_LOW_CFG_ID    1u
#define SYSTEM_VOLTAGE_MODE_HIGH_CFG_ID   2u


#define NUM_OF_SYSTEM_VOLTAGE_MANAGE    3u


#define SYSTEM_VOLTAGE_MODE_NORMAL                      0u
#define SYSTEM_VOLTAGE_MODE_LOW                         1u
#define SYSTEM_VOLTAGE_MODE_HIGH                        2u
#define SYSTEM_VOLTAGE_MODE_UNKNOWN                     3u

/*****************************************************************************
* T Y P E   D E F I N I T I O N S
*****************************************************************************/
/*! @brief
 */


/*****************************************************************************
* G L O B A L   V A R I A B L E S
* only configuration table allowed here,variables are not allowed!
*****************************************************************************/


/*****************************************************************************
* C O N S T A N T S
*****************************************************************************/

/*****************************************************************************
* F U N C T I O N   P R O T O T Y P E
*****************************************************************************/
uint16_t system_voltage_cfg_min_get(uint8_t system_voltage_manage_id, uint8_t system_voltage_mode_id);
uint16_t system_voltage_cfg_max_get(uint8_t system_voltage_manage_id, uint8_t system_voltage_mode_id);
uint16_t system_voltage_cfg_debounce_time_get(uint8_t system_voltage_manage_id, uint8_t system_voltage_mode_id);


#if (SYSTEM_VOLTAGE_MANAGE_DEBUG_EN == 1u)
uint16_t system_voltage_cfg_get_sys_power(void);
#define SYSTEM_VOLTAGE_MANAGE_GET_ADC_MV()   system_voltage_cfg_get_sys_power()

#else

#define SYSTEM_VOLTAGE_MANAGE_GET_ADC_MV() adc_manage_get_sbat_voltage();//TODO 添加实际系统电压mV单位的函数

#endif




#endif /*DEFINES_NAME*/

/* [] END OF FILE */