﻿/** ##########################################################################
**     Filename  : common_types.h
**     Project   : 
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :  主要用於批量處理數據，如初始化，復制，清除等等
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef COMMON_MEMORY__H
#define COMMON_MEMORY__H

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/
typedef enum
{
	MEMORY_RESULT_DIFFERENT = 0U,
	MEMORY_RESULT_SAME = 1U
}memory_result_t;

/*---------------------------------------------------------------------------
- G L O B A L   V A R I A B L E S
- only configuration table allowed here,variables are not allowed!
----------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/
void common_memory_copys(u8* dst,const u8* src,u16 length);
void common_memory_clear(u8 *dst , u16 length);
void common_memory_fill(u8 *dst , u8 value, u16 length);
memory_result_t common_memory_compare(const u8 *dst , const u8 *src, u16 length);





#endif /* COMMON_MEMORY__H */

/* [] END OF FILE */
