﻿/** ##########################################################################
**     Filename  :
**     Project   :
**     Module    :
**     Processor :
**     Version   : 1.0
**     Compiler  :
**     Date/Time :
**     Abstract  :
**     Contents  :
**     Note      :
**
**     (c) Copyright dmdz Co.,Ltd
**  --------------------------------------------------------------------------
**               R E V I S I O N   H I S T O R Y
**  --------------------------------------------------------------------------
**  Date       Ver   Author             Description

**  -20230602-  --V1.0--  --mingyea---  --修改--

** #########################################################################*/
#ifndef	NVM_CFG_H__
#define NVM_CFG_H__

/*---------------------------------------------------------------------------
- I N C L U D E   F I L E S
----------------------------------------------------------------------------*/
#include "common_types.h"
#include "boot_app_cfg.h"

/*---------------------------------------------------------------------------
- D E F I N E S / M A C R O S
----------------------------------------------------------------------------*/

//整片flash 的大小， 这里要去掉，被映射为eeprom的地址
#define FLASH_P_BLOCK_SIZES (FLASH_ASW_MAX_ADDR-FLASH_APP_BASE)
#define FLASH_P_BLOCK_END_ADDR (FLASH_P_BLOCK_SIZES-1)

#define FEATURE_FLS_PF_BLOCK_SECTOR_SIZE (2048u)
#define FLASH_P_BLOCK_SECTOR_SIZES  (FEATURE_FLS_PF_BLOCK_SECTOR_SIZE/2u)    //1k  //為了配合block大小，
#define FLASH_P_PAGE_SIZES 8u  //要不要改成512字节


#define FLASH_START_ADDR  0x00000000UL
#define FLASH_END_ADDR  (FLASH_ASW_MAX_ADDR-1u)   //目前是128k的单片机



//只能对这些区域写，安全
#define RAM_START_ADDR  0x20007FC0u
#define RAM_END_ADDR  0x20007FCFu

/*---------------------------------------------------------------------------
- T Y P E   D E F I N I T I O N S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- S T A T I C   V A R I A B L E S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
* G L O B A L   V A R I A B L E S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- C O N S T A N T S
----------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
- F U N C T I O N   P R O T O T Y P E
----------------------------------------------------------------------------*/

//#define NVM_FLASH_DEBUG_EN  1


#ifdef NVM_FLASH_DEBUG_EN
void nvm_falsh_init(void);
void nvm_flash_test(void);
#endif




#endif
